diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/CRISRawApplicationPackets2.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/CRISRawApplicationPackets2.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/CRISRawApplicationPackets2.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/CRISRawApplicationPackets2.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 2,161 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
- 
- 
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  import ncsa.hdf.hdf5lib.exceptions.HDF5LibraryException;
  
  /**
!  * Build CrIS [@link RawApplicationPackets} by capturing groups scan packets between packet with
!  * and application ID of 1289.  The first group captured is likely going to be short due
!  * to the fact that frame lock could occur at any time.  Scans groups that form a granule are specified
!  * externally in the constructor.
   * 
   * Current
!  *
   */
  public class CRISRawApplicationPackets2 extends RawApplicationPackets {
  	private final int scansPerGranule = 4; // approx x secs worth
  	private Stats stats = null;
! 	private int scanCount = -1;  // FIXME also likely a bug
  	private int sciPacketCount = 0;
! 	
  	/**
  	 * Constructor to initialize the RawApplicationPackets algorithm for CrIS.
! 	 * @param satellite the satellite ID as defined by the mission documents
! 	 * @param setNum the set number which is appended to the end of each RawApplicationPacket in the HDF
! 	 * @param scansPerGranule The number of scans to collect to make one granule
  	 */
! 	public CRISRawApplicationPackets2(SpacecraftId satellite, int setNum, int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.CrIS_Science, setNum, packetPool);
! 		
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
! 		
! 		
! 		
  	}
! 	
! 	public CRISRawApplicationPackets2(Stats stats, SpacecraftId satellite, int setNum, int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.CrIS_Science, setNum, packetPool);
! 		
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
! 		
! 	
  		this.stats = stats;
  	}
  
- 	
- 	
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that pre-exists.
! 	 * The contents of the dataspace are read into a memory buffer... assuming it will fit.
! 	 * @param allRDRId  the rdrAll Groups id
! 	 * @param setNum the set number of raw entry
! 	 * @throws RtStpsException 
! 	 * @throws NullPointerException 
! 	 * @throws HDF5LibraryException 
  	 */
! 	public CRISRawApplicationPackets2(int allRDRId, int setNum) throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 	
! 	public CRISRawApplicationPackets2(int readId, int setNum, boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
  
  	/**
! 	 * Granules are created from scans.  Scans in CrIS are lots of packets but the 8 second
! 	 * packet <b>seems</b> to indicate the start of a scan.   We collect it and everything after it
! 	 * as one scan until it re-appears.  Anything more complex than this can be built on top of this
! 	 * one assumption.
! 	 * 
! 	 * @param p  a Packet to be put into the CrIS RawApplicationPackets area
! 	 * @return true if it can be put there, or false if it is full and should be written to disk first
! 	 * @exception wraps any HDF exceptions in RtStpsException
  	 */
  	public boolean notFull(Packet p) throws RtStpsException {
! 		
  		// every appearance of 1289 means start of scan
! 		
! 		if (p.isStandalonePacket() && p.hasSecondaryHeader()) {
! 			if (p.getApplicationId() == 1289) {
! 				
  					
! 						++scanCount;
  					
  			}
  		}
! 		return (scanCount < scansPerGranule);  // true == not full, false == full
! 		
  
  	}
! 	
! 	
! 	
! 	/**
! 	 * Put the packet into the CrISRawApplications area, the method <code>notFull</code> should
! 	 * have been called first to check if this is allowed or not.
! 	 * @param p a Packet to put into it
! 	 * @exception wraps any HDF exceptions in RtStpsException
  	 */
  	public void put(Packet p) throws RtStpsException {
! 		if (scanCount < 0) { // throw away any initial packets if we've not seen the start of a scan...
! 			if (stats == null) {
! 				System.out.println("Trimming CrIS [" + p.getApplicationId() + "]");
! 			} else {
! 				//stats.sci_trimmedPackets.value++;
! 			}
! 			return;
! 		}
  		sciPacketCount++;
! 		
  		this.updateAppIdCounters(p.getApplicationId());
! 		
  		RDRName rdrName = RDRName.fromAppId(p.getApplicationId());
! 		
  		if (rdrName != RDRName.CrIS_Science) {
! 			throw new RtStpsException("Not a CrIS science packet [" + p.getApplicationId() + "]");
  		}
  
  		// collect time info
  		if (p.hasSecondaryHeader()) {
  
! 			// secondary time stamp only valid in in first or standalone packets...
  			if (getFirstTime() == 0L) {
! 				//System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 			
  			setLastTime(p.getTimeStamp(8));
  		}
  		Packet pcopy = CopyPacket.deep(p, packetPool);
  		getPacketList().add(pcopy);
  	}
! 	
  	/**
! 	 * Write the accumulate packets to the RDR/HDF file.  Note that this method
! 	 * must be used in conjunction with method <code>notFull</code> and <code>put</code>.
! 	 * @param hdfFile the handle to the RDR/HDF file that the packets should written to
  	 * @return true if the write succeeded
! 	 * @exception wraps any HDF exceptions in RtStpsException
  	 */
! 	public boolean write(int hdfFile) throws RtStpsException  {
! 		
  		boolean ret = true;
  		if (this.scanCount < this.scansPerGranule) {
  
  			if (stats == null) {
! 				System.out.println("Deleting partial CrIS Granule -- [" + scanCount + "] scans");
  			} else {
  				stats.sci_discardedGranules.value++;
  			}
--- 2,249 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  import gov.nasa.gsfc.drl.rtstps.core.RtStpsException;
  import gov.nasa.gsfc.drl.rtstps.core.ccsds.Packet;
  import ncsa.hdf.hdf5lib.exceptions.HDF5LibraryException;
  
  /**
!  * Build CrIS [@link RawApplicationPackets} by capturing groups scan packets
!  * between packet with and application ID of 1289. The first group captured is
!  * likely going to be short due to the fact that frame lock could occur at any
!  * time. Scans groups that form a granule are specified externally in the
!  * constructor.
   * 
   * Current
!  * 
   */
  public class CRISRawApplicationPackets2 extends RawApplicationPackets {
  	private final int scansPerGranule = 4; // approx x secs worth
  	private Stats stats = null;
! 	private int scanCount = -1; // FIXME also likely a bug
  	private int sciPacketCount = 0;
! 
  	/**
  	 * Constructor to initialize the RawApplicationPackets algorithm for CrIS.
! 	 * 
! 	 * @param satellite
! 	 *            the satellite ID as defined by the mission documents
! 	 * @param setNum
! 	 *            the set number which is appended to the end of each
! 	 *            RawApplicationPacket in the HDF
! 	 * @param scansPerGranule
! 	 *            The number of scans to collect to make one granule
  	 */
! 	public CRISRawApplicationPackets2(SpacecraftId satellite, int setNum,
! 			int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.CrIS_Science, setNum, packetPool);
! 
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
! 
  	}
! 
! 	public CRISRawApplicationPackets2(Stats stats, SpacecraftId satellite,
! 			int setNum, int scansPerGranule, PacketPool packetPool) {
  		super(satellite, RDRName.CrIS_Science, setNum, packetPool);
! 
  		if (setNum < 0) {
  			throw new IllegalArgumentException("Illegal Index [" + setNum + "]");
  		}
! 
  		this.stats = stats;
  	}
  
  	/**
! 	 * Constructor which attempts to read the RawApplicationPacket entry that
! 	 * pre-exists. The contents of the dataspace are read into a memory
! 	 * buffer... assuming it will fit.
! 	 * 
! 	 * @param allRDRId
! 	 *            the rdrAll Groups id
! 	 * @param setNum
! 	 *            the set number of raw entry
! 	 * @throws RtStpsException
! 	 * @throws NullPointerException
! 	 * @throws HDF5LibraryException
  	 */
! 	public CRISRawApplicationPackets2(int allRDRId, int setNum)
! 			throws RtStpsException {
  		super(allRDRId, setNum);
  	}
! 
! 	public CRISRawApplicationPackets2(int readId, int setNum,
! 			boolean usedByGranuleOnly) throws RtStpsException {
  		super(readId, setNum, true);
  	}
  
+ 	private static long firstTime = 0;
+ 
+ 	// /**
+ 	// * Granules are created from scans. Scans in CrIS are lots of packets but
+ 	// the 8 second
+ 	// * packet <b>seems</b> to indicate the start of a scan. We collect it and
+ 	// everything after it
+ 	// * as one scan until it re-appears. Anything more complex than this can be
+ 	// built on top of this
+ 	// * one assumption.
+ 	// *
+ 	// * @param p a Packet to be put into the CrIS RawApplicationPackets area
+ 	// * @return true if it can be put there, or false if it is full and should
+ 	// be written to disk first
+ 	// * @exception wraps any HDF exceptions in RtStpsException
+ 	// */
+ 	// public boolean notFull(Packet p) throws RtStpsException {
+ 	//
+ 	// // every appearance of 1289 means start of scan
+ 	//
+ 	// if (p.isStandalonePacket() && p.hasSecondaryHeader()) {
+ 	// if (p.getApplicationId() == 1289) {
+ 	//
+ 	//
+ 	// ++scanCount;
+ 	//
+ 	// }
+ 	// }
+ 	// return (scanCount < scansPerGranule); // true == not full, false == full
+ 	//
+ 	//
+ 	// }
  	/**
! 	 * Granules are created from scans. Scans in CrIS are lots of packets but
! 	 * the 8 second packet <b>seems</b> to indicate the start of a scan. We
! 	 * collect it and everything after it as one scan until it re-appears.
! 	 * Anything more complex than this can be built on top of this one
! 	 * assumption.
! 	 * 
! 	 * @param p
! 	 *            a Packet to be put into the CrIS RawApplicationPackets area
! 	 * @return true if it can be put there, or false if it is full and should be
! 	 *         written to disk first
! 	 * @exception wraps
! 	 *                any HDF exceptions in RtStpsException
  	 */
  	public boolean notFull(Packet p) throws RtStpsException {
! 
  		// every appearance of 1289 means start of scan
! 		boolean notFull = true;
! 
! 		long timestamp = p.getTimeStamp(8);
! 
! 		GranuleId currentGranId = new GranuleId(SpacecraftId.npp,
! 				p.getTimeStamp(8),  RDRName.CrIS_Science);
! 
! 		// System.out.printf("VIIRS: Gran %s seq %d ts %d obs %d \n",
! 		// currentGranId.toString(), p.getSequenceCounter(),
! 		// timestamp, obsTime.getMicrosSinceEpoch());
! 
! 		if (currentGranId.toString().startsWith("NPP-") == false) {
! 
! 			if (CRISRawApplicationPackets2.firstTime < 0l) {
! 				CRISRawApplicationPackets2.firstTime = timestamp;
! 				setFirstTime(timestamp);
! 				scanCount=0;
! 			} else {
! 				GranuleId startGranId = new GranuleId(SpacecraftId.npp,
! 						getFirstTime(),  RDRName.CrIS_Science);
! 
! 				if (startGranId.toString().contentEquals(
! 						currentGranId.toString()) == false) {
! 					firstTime = -1;
! //					System.out.println("GRAN CRIS: " + startGranId.toString()
! //							+ " Current:" + currentGranId.toString());
  					
! 					System.out.printf("GRAN  CRIS: %s Current: %s  packid: %d APID:%d \n",startGranId.toString(),currentGranId.toString(),p.getSequenceCounter(),p.getApplicationId());
  					
+ 
+ 					notFull = false; // if 20secs have gone by, the granule
+ 
+ 				}
+ 				else
+ 				{
+ 					scanCount++;
+ 					setLastTime(timestamp);
+ 				}
  			}
  		}
! 
! 		return notFull;
  
  	}
! 
! 	/**
! 	 * Put the packet into the CrISRawApplications area, the method
! 	 * <code>notFull</code> should have been called first to check if this is
! 	 * allowed or not.
! 	 * 
! 	 * @param p
! 	 *            a Packet to put into it
! 	 * @exception wraps
! 	 *                any HDF exceptions in RtStpsException
  	 */
  	public void put(Packet p) throws RtStpsException {
! //		if (scanCount < 0) { // throw away any initial packets if we've not seen
! //								// the start of a scan...
! //			if (stats == null) {
! //				System.out.println("Trimming CrIS [" + p.getApplicationId()
! //						+ "]");
! //			} else {
! //				// stats.sci_trimmedPackets.value++;
! //			}
! //			return;
! //		}
  		sciPacketCount++;
! 
  		this.updateAppIdCounters(p.getApplicationId());
! 
  		RDRName rdrName = RDRName.fromAppId(p.getApplicationId());
! 
  		if (rdrName != RDRName.CrIS_Science) {
! 			throw new RtStpsException("Not a CrIS science packet ["
! 					+ p.getApplicationId() + "]");
  		}
  
  		// collect time info
  		if (p.hasSecondaryHeader()) {
  
! 			// secondary time stamp only valid in in first or standalone
! 			// packets...
  			if (getFirstTime() == 0L) {
! 				// System.out.println("Here...");
  				setFirstTime(p.getTimeStamp(8));
  			}
! 
  			setLastTime(p.getTimeStamp(8));
  		}
+ //		System.out.println("ATMS Add packet");
+ 
  		Packet pcopy = CopyPacket.deep(p, packetPool);
  		getPacketList().add(pcopy);
  	}
! 
  	/**
! 	 * Write the accumulate packets to the RDR/HDF file. Note that this method
! 	 * must be used in conjunction with method <code>notFull</code> and
! 	 * <code>put</code>.
! 	 * 
! 	 * @param hdfFile
! 	 *            the handle to the RDR/HDF file that the packets should written
! 	 *            to
  	 * @return true if the write succeeded
! 	 * @exception wraps
! 	 *                any HDF exceptions in RtStpsException
  	 */
! 	public boolean write(int hdfFile) throws RtStpsException {
! 
  		boolean ret = true;
  		if (this.scanCount < this.scansPerGranule) {
  
  			if (stats == null) {
! 				System.out.println("Deleting partial CrIS Granule -- ["
! 						+ scanCount + "] scans");
  			} else {
  				stats.sci_discardedGranules.value++;
  			}
***************
*** 164,197 ****
  		} else {
  
  			if (stats == null) {
! 				System.out.println("Creating CrIS Granule with [" + scanCount + "] scans");
  			} else {
  				stats.sci_createdGranules.value++;
  			}
  
  			ret = super.write(hdfFile);
  		}
! 		
! 		System.out.println("CrIS Sci packets in granule: " + sciPacketCount + " Packets per scan: " + (float)sciPacketCount / (float)scansPerGranule);
! 		System.out.println("CrIS app ids = " + super.appIdCountersToString(scansPerGranule));
  		scanCount = -1;
! 		
  		sciPacketCount = 0;
! 		
  		return ret;
  	}
  
  	/**
! 	 * Close the RDR/HDF file specifically for the RawApplicationsPackets.  This method should be 
! 	 * called once specific RawApplicationPacket_x has been written. 
! 	 * @exception wraps any HDF exceptions in RtStpsException
  	 */
! 	public void close() throws RtStpsException  {
  		super.close();
  		scanCount = -1;
! 		
  		sciPacketCount = 0;
  	}
  
- 
  }
--- 252,291 ----
  		} else {
  
  			if (stats == null) {
! 				System.out.println("Creating CrIS Granule with [" + scanCount
! 						+ "] scans");
  			} else {
  				stats.sci_createdGranules.value++;
  			}
  
  			ret = super.write(hdfFile);
  		}
! 
! 		System.out.println("CrIS Sci packets in granule: " + sciPacketCount
! 				+ " Packets per scan: " + (float) sciPacketCount
! 				/ (float) scansPerGranule);
! 		System.out.println("CrIS app ids = "
! 				+ super.appIdCountersToString(scansPerGranule));
  		scanCount = -1;
! 
  		sciPacketCount = 0;
! 
  		return ret;
  	}
  
  	/**
! 	 * Close the RDR/HDF file specifically for the RawApplicationsPackets. This
! 	 * method should be called once specific RawApplicationPacket_x has been
! 	 * written.
! 	 * 
! 	 * @exception wraps
! 	 *                any HDF exceptions in RtStpsException
  	 */
! 	public void close() throws RtStpsException {
  		super.close();
  		scanCount = -1;
! 
  		sciPacketCount = 0;
  	}
  
  }
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/GranuleId.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/GranuleId.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/GranuleId.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/GranuleId.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 2,102 ****
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
! */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
- 
  /**
!  * A Granule identifier is a way of calculating a unique identifier for the IDPS system.  It is specified as part of
!  * RDR attributes for granules in the specifications.   This implements the formula.   One item the firstAscendingNodeAfterLaunch is
!  * currenlty not known.
   * 
   * 
-  *
   */
  public class GranuleId {
  	private String name;
! 	
  	// FIXME this is hack for now until this gets defined better...
! 	//public static PDSDate  firstAscendingNodeAfterLaunch = new PDSDate(1958, 0, 1, 0, 0, 0, 0, 0); // new PDSDate(2009, 0, 25, 0, 0, 0, 0, 0);
! 	public static PDSDate  firstAscendingNodeAfterLaunch = new PDSDate(2011, 10, 28, 10, 50, 0, 0, 0); // new PDSDate(2009, 0, 25, 0, 0, 0, 0, 0);
  
  	/**
! 	 * Use only for the case of reading the ID from the attributes in an HDF file
  	 * @param granuleIdStr
  	 */
  	public GranuleId(String granuleIdStr) {
  		this.name = granuleIdStr;
  	}
! 	
  	/**
  	 * Build a granuleId from various inputs
! 	 * @param spacecraftId the spacecraft identifier
! 	 * @param pktObservationTime the observation time of the packet
! 	 * @param firstAscendingNodeAfterLaunch the first ascending now after launch (currently not known)
! 	 * @param granuleSizeInTime the granule size in time, this would be time span from first and last packets in the granule in microseconds 
! 	 */
! 	public GranuleId(SpacecraftId spacecraftId, PDSDate pktObservationTime, PDSDate firstAscendingNodeAfterLaunch, long granuleSizeInTime) {
! 		name = String.format("%s%012d", spacecraftId.toString(), granuleIDValue(pktObservationTime, GranuleId.firstAscendingNodeAfterLaunch, granuleSizeInTime) );
  	}
! 	
  	/**
! 	 * Build a granule ID from various inputs, most importantly the times are in 64-bit quantities
! 	 * @param spacecraftId the spacecraft identifier
! 	 * @param pktObservationTime the packet observation time in microseconds
! 	 * @param firstAscendingNodeAfterLaunch the first ascending node after launch (currently unknown)
! 	 * @param granuleSizeInTime the granule size in time (microseconds)
! 	 */
! 	public GranuleId(SpacecraftId spacecraftId, long pktObservationTime, long firstAscendingNodeAfterLaunch, long granuleSizeInTime) {
! 		PDSDate obsTime = new PDSDate(pktObservationTime);
! 		PDSDate fanLaunchTime = new PDSDate(firstAscendingNodeAfterLaunch);
  		
! 		name = String.format("%s%012d", spacecraftId.toString(), granuleIDValue(obsTime, GranuleId.firstAscendingNodeAfterLaunch, granuleSizeInTime) );
  	}
! 	
  	/**
  	 * This implements the formula, taking from the JPSS documentation
! 	 * @param pktObservationTime the packet observation time in microseconds
! 	 * @param firstAscendingNodeAfterLaunch the first ascending node after launch (currently unknown)
! 	 * @param granuleSizeInTime the first ascending node after launch (currently unknown)
  	 * @return the calculated identifier as an <code>long</code>
  	 */
! 	private long granuleIDValue(long pktObservationTime, long firstAscendingNodeAfterLaunch, long granuleSizeInTime) {
! 		
! 		long numberG = (pktObservationTime - firstAscendingNodeAfterLaunch ) / granuleSizeInTime;  // floor
! 		long granuleStartTime = numberG * granuleSizeInTime + firstAscendingNodeAfterLaunch;
! 		long granuleEndTime = granuleStartTime + granuleSizeInTime;
! 		long granuleIDValue = (numberG * granuleSizeInTime ) / 100000L; // 10^5;
! 		
! 		//System.out.println("GranuleIDValue = " + granuleIDValue);
  		return granuleIDValue;
  	}
  
- 	
  	/**
! 	 * This implements the formula, taking from the JPSS documentation but uses {@link PDSDate} as inputs
! 	 * @param pktObservationTime the packet observation time as a <code>PDSDate</code>
! 	 * @param firstAscendingNodeAfterLaunch the first ascending node after launch (currently unknown) as a <code>PDSDate</code>
! 	 * @param granuleSizeInTime the first ascending node after launch (currently unknown)
  	 * @return the calculated identifier as an <code>long</code>
  	 */
! 	private long granuleIDValue(PDSDate pktObservationTime, PDSDate firstAscendingNodeAfterLaunch, long granuleSizeInTime) {
! 		//System.out.println("obsTime: "  + pktObservationTime.toString());
! 		
! 		//System.out.println("firstAscendingNodeAfterLaunch: "  + firstAscendingNodeAfterLaunch.toString());
! 		
! 		//System.out.println("GranuleSizeInTime: " + granuleSizeInTime);
! 		
  
- 		
- 		return this.granuleIDValue(pktObservationTime.getMicrosSinceEpoch(), 
- 							firstAscendingNodeAfterLaunch.getMicrosSinceEpoch(), 
- 							granuleSizeInTime); 
- 		
  	}
! 	
  	/**
  	 * Return the GranuleId in a <code>String</code>
  	 * @return a string with the granule identifier
  	 */
  	public String toString() {
--- 2,215 ----
  Copyright (c) 1999-2007, United States Government, as represented by
  the Administrator for The National Aeronautics and Space Administration.
  All rights reserved.
!  */
  package gov.nasa.gsfc.drl.rtstps.core.output.rdr;
  
  /**
!  * A Granule identifier is a way of calculating a unique identifier for the IDPS
!  * system. It is specified as part of RDR attributes for granules in the
!  * specifications. This implements the formula. One item the
!  * firstAscendingNodeAfterLaunch is currenlty not known.
!  * 
   * 
   * 
   */
  public class GranuleId {
  	private String name;
! 
  	// FIXME this is hack for now until this gets defined better...
! 	// public static PDSDate firstAscendingNodeAfterLaunch = new PDSDate(1958,
! 	// 0, 1, 0, 0, 0, 0, 0); // new PDSDate(2009, 0, 25, 0, 0, 0, 0, 0);
! 	public static PDSDate firstAscendingNodeAfterLaunch = new PDSDate(2011, 10,
! 			28, 10, 50, 0, 0, 0); // new PDSDate(2009, 0, 25, 0, 0, 0, 0, 0);
! 	// public static Long FirstTimeAscend=1300968033000000L; // preflight
! 	public static Long FirstTimeAscend = 1698019234000000L; // flight // SSEC
! 															// SRM 2/2/2012
! 
! 	public final static long NPP_SPACECRAFT_DIARY_GRANULE_SIZE = 20000000;
! 	public final static long NPP_VIIRS_SCIENCE_GRANULE_SIZE = 85350000;
! 	public final static long NPP_CRIS_SCIENCE_GRANULE_SIZE = 31997000;
! 	public final static long NPP_ATMS_SCIENCE_GRANULE_SIZE = 31997000;
  
  	/**
! 	 * Use only for the case of reading the ID from the attributes in an HDF
! 	 * file
! 	 * 
  	 * @param granuleIdStr
  	 */
  	public GranuleId(String granuleIdStr) {
  		this.name = granuleIdStr;
  	}
! 
  	/**
  	 * Build a granuleId from various inputs
! 	 * 
! 	 * @param spacecraftId
! 	 *            the spacecraft identifier
! 	 * @param pktObservationTime
! 	 *            the observation time of the packet
! 	 * @param firstAscendingNodeAfterLaunch
! 	 *            the first ascending now after launch (currently not known)
! 	 * @param granuleSizeInTime
! 	 *            the granule size in time, this would be time span from first
! 	 *            and last packets in the granule in microseconds
! 	 */
! 	public GranuleId(SpacecraftId spacecraftId, PDSDate pktObservationTime,
! 			RDRName rdrName) {
! 		name = String.format("%s%012d", spacecraftId.toString(),
! 				granuleIDValue(pktObservationTime, rdrName));
  	}
! 
  	/**
! 	 * Build a granule ID from various inputs, most importantly the times are in
! 	 * 64-bit quantities
! 	 * 
! 	 * @param spacecraftId
! 	 *            the spacecraft identifier
! 	 * @param pktObservationTime
! 	 *            the packet observation time in microseconds
! 	 * @param firstAscendingNodeAfterLaunch
! 	 *            the first ascending node after launch (currently unknown)
! 	 * @param granuleSizeInTime
! 	 *            the granule size in time (microseconds)
! 	 */
! 	public GranuleId(SpacecraftId spacecraftId, long pktObservationTime,
! 			RDRName rdrName) {
! 
! 		// PDSDate obsTime = new PDSDate(pktObservationTime);
! 		LeapDate obsTime = new LeapDate(pktObservationTime); // srm
! 
! 	
! 
! 		
  		
! 		name = String.format("%s%012d", spacecraftId.toString(),
! 				granuleIDValue(obsTime, rdrName));
  	}
! 
! 	// FIXME: SSEC - calculating start and end times based on granule
! 	// boundaries, not packet times
! 	public static long getGranuleSize(RDRName myRdrName) {
! 		// FIXME: times should come from table (ideally derived from
! 		// INF_CFG.xml)
! 		if (myRdrName == RDRName.VIIRS_Science) {
! 			return 85350000;
! 		} else if (myRdrName == RDRName.ATMS_Science) {
! 			return 31997000;
! 		} else if (myRdrName == RDRName.CrIS_Science) {
! 			return 31997000;
! 		} else if (myRdrName == RDRName.NPP_Ephemeris_and_Attitude) {
! 			return 20000000;
! 
! 			// FIXME: need to handle other packet types
! 		} else {
! 			System.out.println("getGranuleSize() error: unknown RDR name "
! 					+ myRdrName);
! 			System.exit(-1);
! 			return -1;
! 		}
! 	}
! 
! 	// Copied from GranuleID.java, but should only be done in one place. Can use
! 	// time of any packet in
! 	// granule for this calculation.
! 	public static long calcGranuleStartTime(long ietTime, RDRName myRdrName) {
! 		long granuleSizeInTime = getGranuleSize(myRdrName);
! 		long FirstTimeAscend = 1698019234000000L;
! 		long numberG = (ietTime - FirstTimeAscend) / granuleSizeInTime; // floor
! 		return numberG * granuleSizeInTime + FirstTimeAscend;
! 	}
! 
! 	public static long calcGranuleEndTime(long ietTime, RDRName myRdrName) {
! 		long granuleSizeInTime = getGranuleSize(myRdrName);
! 		return calcGranuleStartTime(ietTime, myRdrName) + granuleSizeInTime;
! 	}
! 
! 	// /**
! 	// * This implements the formula, taking from the JPSS documentation
! 	// * @param pktObservationTime the packet observation time in microseconds
! 	// * @param firstAscendingNodeAfterLaunch the first ascending node after
! 	// launch (currently unknown)
! 	// * @param granuleSizeInTime the first ascending node after launch
! 	// (currently unknown)
! 	// * @return the calculated identifier as an <code>long</code>
! 	// */
! 	// private long granuleIDValue(long pktObservationTime, long
! 	// firstAscendingNodeAfterLaunch, long granuleSizeInTime) {
! 	// firstAscendingNodeAfterLaunch = FirstTimeAscend; // SSEC SRM 2/2/2012
! 	//
! 	// long numberG = (pktObservationTime - firstAscendingNodeAfterLaunch ) /
! 	// granuleSizeInTime; // floor
! 	// long granuleStartTime = numberG * granuleSizeInTime +
! 	// firstAscendingNodeAfterLaunch;
! 	// long granuleEndTime = granuleStartTime + granuleSizeInTime;
! 	// long granuleIDValue = (numberG * granuleSizeInTime ) / 100000L; // 10^5;
! 	//
! 	// //System.out.println("GranuleIDValue = " + granuleIDValue);
! 	// return granuleIDValue;
! 	// }
  	/**
  	 * This implements the formula, taking from the JPSS documentation
! 	 * 
! 	 * @param pktObservationTime
! 	 *            the packet observation time in microseconds
! 	 * @param firstAscendingNodeAfterLaunch
! 	 *            the first ascending node after launch (currently unknown)
! 	 * @param granuleSizeInTime
! 	 *            the first ascending node after launch (currently unknown)
  	 * @return the calculated identifier as an <code>long</code>
  	 */
! 	private long granuleIDValue(long pktObservationTime, RDRName rdrName) {
! 
! 		long firstAscendingNodeAfterLaunch = FirstTimeAscend;
! 		long granuleSizeInTime = getGranuleSize(rdrName);
! 		long numberG = (pktObservationTime - firstAscendingNodeAfterLaunch)
! 				/ granuleSizeInTime; // floor
! 		// long granuleStartTime = numberG * granuleSizeInTime +
! 		// firstAscendingNodeAfterLaunch;
! 		// long granuleEndTime = granuleStartTime + granuleSizeInTime;
! 
! 		long granuleIDValue = (numberG * granuleSizeInTime) / 100000L; // 10^5;
! 
! 		//
! 		// System.out.println("GranuleIDValue = " + granuleIDValue
! 		// + " pktObservationTime = " + pktObservationTime + " "
! 		// + granuleSizeInTime + " delta " + delta + " fa "
! 		// + FirstTimeAscend + " " + firstAscendingNodeAfterLaunch + " "
! 		// + isSpace);
! 
  		return granuleIDValue;
  	}
  
  	/**
! 	 * This implements the formula, taking from the JPSS documentation but uses
! 	 * {@link PDSDate} as inputs
! 	 * 
! 	 * @param pktObservationTime
! 	 *            the packet observation time as a <code>PDSDate</code>
! 	 * @param firstAscendingNodeAfterLaunch
! 	 *            the first ascending node after launch (currently unknown) as a
! 	 *            <code>PDSDate</code>
! 	 * @param granuleSizeInTime
! 	 *            the first ascending node after launch (currently unknown)
  	 * @return the calculated identifier as an <code>long</code>
  	 */
! 	private long granuleIDValue(PDSDate pktObservationTime, RDRName rdrName) {
! 		// System.out.println("obsTime: " + pktObservationTime.toString());
! 
! 		// System.out.println("firstAscendingNodeAfterLaunch: " +
! 		// firstAscendingNodeAfterLaunch.toString());
! 
! 		// System.out.println("GranuleSizeInTime: " + granuleSizeInTime);
! 
! 		return this.granuleIDValue(pktObservationTime.getMicrosSinceEpoch(),
! 				rdrName);
  
  	}
! 
  	/**
  	 * Return the GranuleId in a <code>String</code>
+ 	 * 
  	 * @return a string with the granule identifier
  	 */
  	public String toString() {
diff -NcrB /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/HDF5Output.java /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/HDF5Output.java
*** /home/RH5B/RT_STPS_INSTALL/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/HDF5Output.java	2011-12-19 11:21:55.000000000 -0800
--- /home/RH5B/RT_STPS_INSTALL/new/rt-stps/src/gov/nasa/gsfc/drl/rtstps/core/output/rdr/HDF5Output.java	2012-08-21 12:07:24.000000000 -0700
***************
*** 78,84 ****
      @Override
      public void load(org.w3c.dom.Element element, Configuration configuration) throws RtStpsException
      {
!     	//System.out.println("LOAD OF HDF5");
          super.setLinkName(element.getAttribute("label"));
          String mission = element.getAttribute("mission"); 
          String directory = element.getAttribute("directory");
--- 78,84 ----
      @Override
      public void load(org.w3c.dom.Element element, Configuration configuration) throws RtStpsException
      {
!     	System.out.println("LOAD OF HDF5");
          super.setLinkName(element.getAttribute("label"));
          String mission = element.getAttribute("mission"); 
          String directory = element.getAttribute("directory");
